#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Type, Union

import oser

from htf.modbus.protocol import (
    SerialRTUModbusRequest,
    SerialASCIIModbusRequest,
    TCPModbusRequest,
    SerialRTUModbusResponse,
    SerialASCIIModbusResponse,
    TCPModbusResponse,
)


# PDU: Protocol Data Unit)
RequestPDU = oser.ByteStruct
ResponsePDU = oser.ByteStruct

# Requests (ADU: Application Data Unit)
ModbusRequestType = Union[Type[SerialRTUModbusRequest], Type[SerialASCIIModbusRequest], Type[TCPModbusRequest]]
ModbusRequest = Union[SerialRTUModbusRequest, SerialASCIIModbusRequest, TCPModbusRequest]

# Responses (ADU: Application Data Unit)
ModbusResponseType = Union[Type[SerialRTUModbusResponse], Type[SerialASCIIModbusResponse], Type[TCPModbusResponse]]
ModbusResponse = Union[SerialRTUModbusResponse, SerialASCIIModbusResponse, TCPModbusResponse]

# Data Overlays
ModbusDataType = Union[Type[oser.ByteStruct], Type[oser.ByteType]]
ModbusData = Union[oser.ByteStruct, oser.ByteType]
